i18n: am: mark more strings for translation
[git.git] / git-am.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005, 2006 Junio C Hamano
4
5 SUBDIRECTORY_OK=Yes
6 OPTIONS_KEEPDASHDASH=
7 OPTIONS_SPEC="\
8 git am [options] [(<mbox>|<Maildir>)...]
9 git am [options] (--resolved | --skip | --abort)
10 --
11 i,interactive   run interactively
12 b,binary*       (historical option -- no-op)
13 3,3way          allow fall back on 3way merging if needed
14 q,quiet         be quiet
15 s,signoff       add a Signed-off-by line to the commit message
16 u,utf8          recode into utf8 (default)
17 k,keep          pass -k flag to git-mailinfo
18 keep-non-patch  pass -b flag to git-mailinfo
19 keep-cr         pass --keep-cr flag to git-mailsplit for mbox format
20 no-keep-cr      do not pass --keep-cr flag to git-mailsplit independent of am.keepcr
21 c,scissors      strip everything before a scissors line
22 whitespace=     pass it through git-apply
23 ignore-space-change pass it through git-apply
24 ignore-whitespace pass it through git-apply
25 directory=      pass it through git-apply
26 exclude=        pass it through git-apply
27 include=        pass it through git-apply
28 C=              pass it through git-apply
29 p=              pass it through git-apply
30 patch-format=   format the patch(es) are in
31 reject          pass it through git-apply
32 resolvemsg=     override error message when patch failure occurs
33 continue        continue applying patches after resolving a conflict
34 r,resolved      synonyms for --continue
35 skip            skip the current patch
36 abort           restore the original branch and abort the patching operation.
37 committer-date-is-author-date    lie about committer date
38 ignore-date     use current timestamp for author date
39 rerere-autoupdate update the index with reused conflict resolution if possible
40 rebasing*       (internal use for git-rebase)"
41
42 . git-sh-setup
43 . git-sh-i18n
44 prefix=$(git rev-parse --show-prefix)
45 set_reflog_action am
46 require_work_tree
47 cd_to_toplevel
48
49 git var GIT_COMMITTER_IDENT >/dev/null ||
50         die "$(gettext "You need to set your committer info first")"
51
52 if git rev-parse --verify -q HEAD >/dev/null
53 then
54         HAS_HEAD=yes
55 else
56         HAS_HEAD=
57 fi
58
59 cmdline="git am"
60 if test '' != "$interactive"
61 then
62         cmdline="$cmdline -i"
63 fi
64 if test '' != "$threeway"
65 then
66         cmdline="$cmdline -3"
67 fi
68
69 sq () {
70         git rev-parse --sq-quote "$@"
71 }
72
73 stop_here () {
74     echo "$1" >"$dotest/next"
75     git rev-parse --verify -q HEAD >"$dotest/abort-safety"
76     exit 1
77 }
78
79 safe_to_abort () {
80         if test -f "$dotest/dirtyindex"
81         then
82                 return 1
83         fi
84
85         if ! test -s "$dotest/abort-safety"
86         then
87                 return 0
88         fi
89
90         abort_safety=$(cat "$dotest/abort-safety")
91         if test "z$(git rev-parse --verify -q HEAD)" = "z$abort_safety"
92         then
93                 return 0
94         fi
95         gettextln "You seem to have moved HEAD since the last 'am' failure.
96 Not rewinding to ORIG_HEAD" >&2
97         return 1
98 }
99
100 stop_here_user_resolve () {
101     if [ -n "$resolvemsg" ]; then
102             printf '%s\n' "$resolvemsg"
103             stop_here $1
104     fi
105     eval_gettextln "When you have resolved this problem, run \"\$cmdline --resolved\".
106 If you prefer to skip this patch, run \"\$cmdline --skip\" instead.
107 To restore the original branch and stop patching, run \"\$cmdline --abort\"."
108
109     stop_here $1
110 }
111
112 go_next () {
113         rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
114                 "$dotest/patch" "$dotest/info"
115         echo "$next" >"$dotest/next"
116         this=$next
117 }
118
119 cannot_fallback () {
120         echo "$1"
121         gettextln "Cannot fall back to three-way merge."
122         exit 1
123 }
124
125 fall_back_3way () {
126     O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
127
128     rm -fr "$dotest"/patch-merge-*
129     mkdir "$dotest/patch-merge-tmp-dir"
130
131     # First see if the patch records the index info that we can use.
132     cmd="git apply $git_apply_opt --build-fake-ancestor" &&
133     cmd="$cmd "'"$dotest/patch-merge-tmp-index" "$dotest/patch"' &&
134     eval "$cmd" &&
135     GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
136     git write-tree >"$dotest/patch-merge-base+" ||
137     cannot_fallback "$(gettext "Repository lacks necessary blobs to fall back on 3-way merge.")"
138
139     say "$(gettext "Using index info to reconstruct a base tree...")"
140
141     cmd='GIT_INDEX_FILE="$dotest/patch-merge-tmp-index"'
142
143     if test -z "$GIT_QUIET"
144     then
145         eval "$cmd git diff-index --cached --diff-filter=AM --name-status HEAD"
146     fi
147
148     cmd="$cmd git apply --cached $git_apply_opt"' <"$dotest/patch"'
149     if eval "$cmd"
150     then
151         mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
152         mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
153     else
154         cannot_fallback "$(gettext "Did you hand edit your patch?
155 It does not apply to blobs recorded in its index.")"
156     fi
157
158     test -f "$dotest/patch-merge-index" &&
159     his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
160     orig_tree=$(cat "$dotest/patch-merge-base") &&
161     rm -fr "$dotest"/patch-merge-* || exit 1
162
163     say "$(gettext "Falling back to patching base and 3-way merge...")"
164
165     # This is not so wrong.  Depending on which base we picked,
166     # orig_tree may be wildly different from ours, but his_tree
167     # has the same set of wildly different changes in parts the
168     # patch did not touch, so recursive ends up canceling them,
169     # saying that we reverted all those changes.
170
171     eval GITHEAD_$his_tree='"$FIRSTLINE"'
172     export GITHEAD_$his_tree
173     if test -n "$GIT_QUIET"
174     then
175             GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
176     fi
177     git-merge-recursive $orig_tree -- HEAD $his_tree || {
178             git rerere $allow_rerere_autoupdate
179             die "$(gettext "Failed to merge in the changes.")"
180     }
181     unset GITHEAD_$his_tree
182 }
183
184 clean_abort () {
185         test $# = 0 || echo >&2 "$@"
186         rm -fr "$dotest"
187         exit 1
188 }
189
190 patch_format=
191
192 check_patch_format () {
193         # early return if patch_format was set from the command line
194         if test -n "$patch_format"
195         then
196                 return 0
197         fi
198
199         # we default to mbox format if input is from stdin and for
200         # directories
201         if test $# = 0 || test "x$1" = "x-" || test -d "$1"
202         then
203                 patch_format=mbox
204                 return 0
205         fi
206
207         # otherwise, check the first few non-blank lines of the first
208         # patch to try to detect its format
209         {
210                 # Start from first line containing non-whitespace
211                 l1=
212                 while test -z "$l1"
213                 do
214                         read l1 || break
215                 done
216                 read l2
217                 read l3
218                 case "$l1" in
219                 "From "* | "From: "*)
220                         patch_format=mbox
221                         ;;
222                 '# This series applies on GIT commit'*)
223                         patch_format=stgit-series
224                         ;;
225                 "# HG changeset patch")
226                         patch_format=hg
227                         ;;
228                 *)
229                         # if the second line is empty and the third is
230                         # a From, Author or Date entry, this is very
231                         # likely an StGIT patch
232                         case "$l2,$l3" in
233                         ,"From: "* | ,"Author: "* | ,"Date: "*)
234                                 patch_format=stgit
235                                 ;;
236                         *)
237                                 ;;
238                         esac
239                         ;;
240                 esac
241                 if test -z "$patch_format" &&
242                         test -n "$l1" &&
243                         test -n "$l2" &&
244                         test -n "$l3"
245                 then
246                         # This begins with three non-empty lines.  Is this a
247                         # piece of e-mail a-la RFC2822?  Grab all the headers,
248                         # discarding the indented remainder of folded lines,
249                         # and see if it looks like that they all begin with the
250                         # header field names...
251                         tr -d '\015' <"$1" |
252                         sed -n -e '/^$/q' -e '/^[       ]/d' -e p |
253                         sane_egrep -v '^[!-9;-~]+:' >/dev/null ||
254                         patch_format=mbox
255                 fi
256         } < "$1" || clean_abort
257 }
258
259 split_patches () {
260         case "$patch_format" in
261         mbox)
262                 if test t = "$keepcr"
263                 then
264                     keep_cr=--keep-cr
265                 else
266                     keep_cr=
267                 fi
268                 git mailsplit -d"$prec" -o"$dotest" -b $keep_cr -- "$@" > "$dotest/last" ||
269                 clean_abort
270                 ;;
271         stgit-series)
272                 if test $# -ne 1
273                 then
274                         clean_abort "$(gettext "Only one StGIT patch series can be applied at once")"
275                 fi
276                 series_dir=`dirname "$1"`
277                 series_file="$1"
278                 shift
279                 {
280                         set x
281                         while read filename
282                         do
283                                 set "$@" "$series_dir/$filename"
284                         done
285                         # remove the safety x
286                         shift
287                         # remove the arg coming from the first-line comment
288                         shift
289                 } < "$series_file" || clean_abort
290                 # set the patch format appropriately
291                 patch_format=stgit
292                 # now handle the actual StGIT patches
293                 split_patches "$@"
294                 ;;
295         stgit)
296                 this=0
297                 for stgit in "$@"
298                 do
299                         this=`expr "$this" + 1`
300                         msgnum=`printf "%0${prec}d" $this`
301                         # Perl version of StGIT parse_patch. The first nonemptyline
302                         # not starting with Author, From or Date is the
303                         # subject, and the body starts with the next nonempty
304                         # line not starting with Author, From or Date
305                         perl -ne 'BEGIN { $subject = 0 }
306                                 if ($subject > 1) { print ; }
307                                 elsif (/^\s+$/) { next ; }
308                                 elsif (/^Author:/) { s/Author/From/ ; print ;}
309                                 elsif (/^(From|Date)/) { print ; }
310                                 elsif ($subject) {
311                                         $subject = 2 ;
312                                         print "\n" ;
313                                         print ;
314                                 } else {
315                                         print "Subject: ", $_ ;
316                                         $subject = 1;
317                                 }
318                         ' < "$stgit" > "$dotest/$msgnum" || clean_abort
319                 done
320                 echo "$this" > "$dotest/last"
321                 this=
322                 msgnum=
323                 ;;
324         hg)
325                 this=0
326                 for hg in "$@"
327                 do
328                         this=$(( $this + 1 ))
329                         msgnum=$(printf "%0${prec}d" $this)
330                         # hg stores changeset metadata in #-commented lines preceding
331                         # the commit message and diff(s). The only metadata we care about
332                         # are the User and Date (Node ID and Parent are hashes which are
333                         # only relevant to the hg repository and thus not useful to us)
334                         # Since we cannot guarantee that the commit message is in
335                         # git-friendly format, we put no Subject: line and just consume
336                         # all of the message as the body
337                         perl -M'POSIX qw(strftime)' -ne 'BEGIN { $subject = 0 }
338                                 if ($subject) { print ; }
339                                 elsif (/^\# User /) { s/\# User/From:/ ; print ; }
340                                 elsif (/^\# Date /) {
341                                         my ($hashsign, $str, $time, $tz) = split ;
342                                         $tz = sprintf "%+05d", (0-$tz)/36;
343                                         print "Date: " .
344                                               strftime("%a, %d %b %Y %H:%M:%S ",
345                                                        localtime($time))
346                                               . "$tz\n";
347                                 } elsif (/^\# /) { next ; }
348                                 else {
349                                         print "\n", $_ ;
350                                         $subject = 1;
351                                 }
352                         ' <"$hg" >"$dotest/$msgnum" || clean_abort
353                 done
354                 echo "$this" >"$dotest/last"
355                 this=
356                 msgnum=
357                 ;;
358         *)
359                 if test -n "$patch_format"
360                 then
361                         clean_abort "$(eval_gettext "Patch format \$patch_format is not supported.")"
362                 else
363                         clean_abort "$(gettext "Patch format detection failed.")"
364                 fi
365                 ;;
366         esac
367 }
368
369 prec=4
370 dotest="$GIT_DIR/rebase-apply"
371 sign= utf8=t keep= keepcr= skip= interactive= resolved= rebasing= abort=
372 resolvemsg= resume= scissors= no_inbody_headers=
373 git_apply_opt=
374 committer_date_is_author_date=
375 ignore_date=
376 allow_rerere_autoupdate=
377
378 if test "$(git config --bool --get am.keepcr)" = true
379 then
380     keepcr=t
381 fi
382
383 while test $# != 0
384 do
385         case "$1" in
386         -i|--interactive)
387                 interactive=t ;;
388         -b|--binary)
389                 gettextln >&2 "The -b/--binary option has been a no-op for long time, and
390 it will be removed. Please do not use it anymore."
391                 ;;
392         -3|--3way)
393                 threeway=t ;;
394         -s|--signoff)
395                 sign=t ;;
396         -u|--utf8)
397                 utf8=t ;; # this is now default
398         --no-utf8)
399                 utf8= ;;
400         -k|--keep)
401                 keep=t ;;
402         --keep-non-patch)
403                 keep=b ;;
404         -c|--scissors)
405                 scissors=t ;;
406         --no-scissors)
407                 scissors=f ;;
408         -r|--resolved|--continue)
409                 resolved=t ;;
410         --skip)
411                 skip=t ;;
412         --abort)
413                 abort=t ;;
414         --rebasing)
415                 rebasing=t threeway=t ;;
416         -d|--dotest)
417                 die "$(gettext "-d option is no longer supported.  Do not use.")"
418                 ;;
419         --resolvemsg)
420                 shift; resolvemsg=$1 ;;
421         --whitespace|--directory|--exclude|--include)
422                 git_apply_opt="$git_apply_opt $(sq "$1=$2")"; shift ;;
423         -C|-p)
424                 git_apply_opt="$git_apply_opt $(sq "$1$2")"; shift ;;
425         --patch-format)
426                 shift ; patch_format="$1" ;;
427         --reject|--ignore-whitespace|--ignore-space-change)
428                 git_apply_opt="$git_apply_opt $1" ;;
429         --committer-date-is-author-date)
430                 committer_date_is_author_date=t ;;
431         --ignore-date)
432                 ignore_date=t ;;
433         --rerere-autoupdate|--no-rerere-autoupdate)
434                 allow_rerere_autoupdate="$1" ;;
435         -q|--quiet)
436                 GIT_QUIET=t ;;
437         --keep-cr)
438                 keepcr=t ;;
439         --no-keep-cr)
440                 keepcr=f ;;
441         --)
442                 shift; break ;;
443         *)
444                 usage ;;
445         esac
446         shift
447 done
448
449 # If the dotest directory exists, but we have finished applying all the
450 # patches in them, clear it out.
451 if test -d "$dotest" &&
452    last=$(cat "$dotest/last") &&
453    next=$(cat "$dotest/next") &&
454    test $# != 0 &&
455    test "$next" -gt "$last"
456 then
457    rm -fr "$dotest"
458 fi
459
460 if test -d "$dotest"
461 then
462         case "$#,$skip$resolved$abort" in
463         0,*t*)
464                 # Explicit resume command and we do not have file, so
465                 # we are happy.
466                 : ;;
467         0,)
468                 # No file input but without resume parameters; catch
469                 # user error to feed us a patch from standard input
470                 # when there is already $dotest.  This is somewhat
471                 # unreliable -- stdin could be /dev/null for example
472                 # and the caller did not intend to feed us a patch but
473                 # wanted to continue unattended.
474                 test -t 0
475                 ;;
476         *)
477                 false
478                 ;;
479         esac ||
480         die "$(eval_gettext "previous rebase directory \$dotest still exists but mbox given.")"
481         resume=yes
482
483         case "$skip,$abort" in
484         t,t)
485                 die "$(gettext "Please make up your mind. --skip or --abort?")"
486                 ;;
487         t,)
488                 git rerere clear
489                 git read-tree --reset -u HEAD HEAD
490                 orig_head=$(cat "$GIT_DIR/ORIG_HEAD")
491                 git reset HEAD
492                 git update-ref ORIG_HEAD $orig_head
493                 ;;
494         ,t)
495                 if test -f "$dotest/rebasing"
496                 then
497                         exec git rebase --abort
498                 fi
499                 git rerere clear
500                 if safe_to_abort
501                 then
502                         git read-tree --reset -u HEAD ORIG_HEAD
503                         git reset ORIG_HEAD
504                 fi
505                 rm -fr "$dotest"
506                 exit ;;
507         esac
508         rm -f "$dotest/dirtyindex"
509 else
510         # Make sure we are not given --skip, --resolved, nor --abort
511         test "$skip$resolved$abort" = "" ||
512                 die "$(gettext "Resolve operation not in progress, we are not resuming.")"
513
514         # Start afresh.
515         mkdir -p "$dotest" || exit
516
517         if test -n "$prefix" && test $# != 0
518         then
519                 first=t
520                 for arg
521                 do
522                         test -n "$first" && {
523                                 set x
524                                 first=
525                         }
526                         if is_absolute_path "$arg"
527                         then
528                                 set "$@" "$arg"
529                         else
530                                 set "$@" "$prefix$arg"
531                         fi
532                 done
533                 shift
534         fi
535
536         check_patch_format "$@"
537
538         split_patches "$@"
539
540         # -i can and must be given when resuming; everything
541         # else is kept
542         echo " $git_apply_opt" >"$dotest/apply-opt"
543         echo "$threeway" >"$dotest/threeway"
544         echo "$sign" >"$dotest/sign"
545         echo "$utf8" >"$dotest/utf8"
546         echo "$keep" >"$dotest/keep"
547         echo "$scissors" >"$dotest/scissors"
548         echo "$no_inbody_headers" >"$dotest/no_inbody_headers"
549         echo "$GIT_QUIET" >"$dotest/quiet"
550         echo 1 >"$dotest/next"
551         if test -n "$rebasing"
552         then
553                 : >"$dotest/rebasing"
554         else
555                 : >"$dotest/applying"
556                 if test -n "$HAS_HEAD"
557                 then
558                         git update-ref ORIG_HEAD HEAD
559                 else
560                         git update-ref -d ORIG_HEAD >/dev/null 2>&1
561                 fi
562         fi
563 fi
564
565 git update-index -q --refresh
566
567 case "$resolved" in
568 '')
569         case "$HAS_HEAD" in
570         '')
571                 files=$(git ls-files) ;;
572         ?*)
573                 files=$(git diff-index --cached --name-only HEAD --) ;;
574         esac || exit
575         if test "$files"
576         then
577                 test -n "$HAS_HEAD" && : >"$dotest/dirtyindex"
578                 die "$(eval_gettext "Dirty index: cannot apply patches (dirty: \$files)")"
579         fi
580 esac
581
582 # Now, decide what command line options we will give to the git
583 # commands we invoke, based on the result of parsing command line
584 # options and previous invocation state stored in $dotest/ files.
585
586 if test "$(cat "$dotest/utf8")" = t
587 then
588         utf8=-u
589 else
590         utf8=-n
591 fi
592 keep=$(cat "$dotest/keep")
593 case "$keep" in
594 t)
595         keep=-k ;;
596 b)
597         keep=-b ;;
598 *)
599         keep= ;;
600 esac
601 case "$(cat "$dotest/scissors")" in
602 t)
603         scissors=--scissors ;;
604 f)
605         scissors=--no-scissors ;;
606 esac
607 if test "$(cat "$dotest/no_inbody_headers")" = t
608 then
609         no_inbody_headers=--no-inbody-headers
610 else
611         no_inbody_headers=
612 fi
613 if test "$(cat "$dotest/quiet")" = t
614 then
615         GIT_QUIET=t
616 fi
617 if test "$(cat "$dotest/threeway")" = t
618 then
619         threeway=t
620 fi
621 git_apply_opt=$(cat "$dotest/apply-opt")
622 if test "$(cat "$dotest/sign")" = t
623 then
624         SIGNOFF=`git var GIT_COMMITTER_IDENT | sed -e '
625                         s/>.*/>/
626                         s/^/Signed-off-by: /'
627                 `
628 else
629         SIGNOFF=
630 fi
631
632 last=`cat "$dotest/last"`
633 this=`cat "$dotest/next"`
634 if test "$skip" = t
635 then
636         this=`expr "$this" + 1`
637         resume=
638 fi
639
640 while test "$this" -le "$last"
641 do
642         msgnum=`printf "%0${prec}d" $this`
643         next=`expr "$this" + 1`
644         test -f "$dotest/$msgnum" || {
645                 resume=
646                 go_next
647                 continue
648         }
649
650         # If we are not resuming, parse and extract the patch information
651         # into separate files:
652         #  - info records the authorship and title
653         #  - msg is the rest of commit log message
654         #  - patch is the patch body.
655         #
656         # When we are resuming, these files are either already prepared
657         # by the user, or the user can tell us to do so by --resolved flag.
658         case "$resume" in
659         '')
660                 if test -f "$dotest/rebasing"
661                 then
662                         commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
663                                 -e q "$dotest/$msgnum") &&
664                         test "$(git cat-file -t "$commit")" = commit ||
665                                 stop_here $this
666                         git cat-file commit "$commit" |
667                         sed -e '1,/^$/d' >"$dotest/msg-clean"
668                         echo "$commit" >"$dotest/original-commit"
669                         get_author_ident_from_commit "$commit" >"$dotest/author-script"
670                         git diff-tree --root --binary "$commit" >"$dotest/patch"
671                 else
672                         git mailinfo $keep $no_inbody_headers $scissors $utf8 "$dotest/msg" "$dotest/patch" \
673                                 <"$dotest/$msgnum" >"$dotest/info" ||
674                                 stop_here $this
675
676                         # skip pine's internal folder data
677                         sane_grep '^Author: Mail System Internal Data$' \
678                                 <"$dotest"/info >/dev/null &&
679                                 go_next && continue
680
681                         test -s "$dotest/patch" || {
682                                 eval_gettextln "Patch is empty.  Was it split wrong?
683 If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
684 To restore the original branch and stop patching run \"\$cmdline --abort\"."
685                                 stop_here $this
686                         }
687                         rm -f "$dotest/original-commit" "$dotest/author-script"
688                         {
689                                 sed -n '/^Subject/ s/Subject: //p' "$dotest/info"
690                                 echo
691                                 cat "$dotest/msg"
692                         } |
693                         git stripspace > "$dotest/msg-clean"
694                 fi
695                 ;;
696         esac
697
698         if test -f "$dotest/author-script"
699         then
700                 eval $(cat "$dotest/author-script")
701         else
702                 GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
703                 GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
704                 GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
705         fi
706
707         if test -z "$GIT_AUTHOR_EMAIL"
708         then
709                 gettextln "Patch does not have a valid e-mail address."
710                 stop_here $this
711         fi
712
713         export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
714
715         case "$resume" in
716         '')
717             if test '' != "$SIGNOFF"
718             then
719                 LAST_SIGNED_OFF_BY=`
720                     sed -ne '/^Signed-off-by: /p' \
721                     "$dotest/msg-clean" |
722                     sed -ne '$p'
723                 `
724                 ADD_SIGNOFF=`
725                     test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
726                     test '' = "$LAST_SIGNED_OFF_BY" && echo
727                     echo "$SIGNOFF"
728                 }`
729             else
730                 ADD_SIGNOFF=
731             fi
732             {
733                 if test -s "$dotest/msg-clean"
734                 then
735                         cat "$dotest/msg-clean"
736                 fi
737                 if test '' != "$ADD_SIGNOFF"
738                 then
739                         echo "$ADD_SIGNOFF"
740                 fi
741             } >"$dotest/final-commit"
742             ;;
743         *)
744                 case "$resolved$interactive" in
745                 tt)
746                         # This is used only for interactive view option.
747                         git diff-index -p --cached HEAD -- >"$dotest/patch"
748                         ;;
749                 esac
750         esac
751
752         resume=
753         if test "$interactive" = t
754         then
755             test -t 0 ||
756             die "$(gettext "cannot be interactive without stdin connected to a terminal.")"
757             action=again
758             while test "$action" = again
759             do
760                 gettextln "Commit Body is:"
761                 echo "--------------------------"
762                 cat "$dotest/final-commit"
763                 echo "--------------------------"
764                 # TRANSLATORS: Make sure to include [y], [n], [e], [v] and [a]
765                 # in your translation. The program will only accept English
766                 # input at this point.
767                 gettext "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
768                 read reply
769                 case "$reply" in
770                 [yY]*) action=yes ;;
771                 [aA]*) action=yes interactive= ;;
772                 [nN]*) action=skip ;;
773                 [eE]*) git_editor "$dotest/final-commit"
774                        action=again ;;
775                 [vV]*) action=again
776                        git_pager "$dotest/patch" ;;
777                 *)     action=again ;;
778                 esac
779             done
780         else
781             action=yes
782         fi
783
784         if test -f "$dotest/final-commit"
785         then
786                 FIRSTLINE=$(sed 1q "$dotest/final-commit")
787         else
788                 FIRSTLINE=""
789         fi
790
791         if test $action = skip
792         then
793                 go_next
794                 continue
795         fi
796
797         if test -x "$GIT_DIR"/hooks/applypatch-msg
798         then
799                 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
800                 stop_here $this
801         fi
802
803         say "$(eval_gettext "Applying: \$FIRSTLINE")"
804
805         case "$resolved" in
806         '')
807                 # When we are allowed to fall back to 3-way later, don't give
808                 # false errors during the initial attempt.
809                 squelch=
810                 if test "$threeway" = t
811                 then
812                         squelch='>/dev/null 2>&1 '
813                 fi
814                 eval "git apply $squelch$git_apply_opt"' --index "$dotest/patch"'
815                 apply_status=$?
816                 ;;
817         t)
818                 # Resolved means the user did all the hard work, and
819                 # we do not have to do any patch application.  Just
820                 # trust what the user has in the index file and the
821                 # working tree.
822                 resolved=
823                 git diff-index --quiet --cached HEAD -- && {
824                         gettextln "No changes - did you forget to use 'git add'?
825 If there is nothing left to stage, chances are that something else
826 already introduced the same changes; you might want to skip this patch."
827                         stop_here_user_resolve $this
828                 }
829                 unmerged=$(git ls-files -u)
830                 if test -n "$unmerged"
831                 then
832                         gettextln "You still have unmerged paths in your index
833 did you forget to use 'git add'?"
834                         stop_here_user_resolve $this
835                 fi
836                 apply_status=0
837                 git rerere
838                 ;;
839         esac
840
841         if test $apply_status != 0 && test "$threeway" = t
842         then
843                 if (fall_back_3way)
844                 then
845                     # Applying the patch to an earlier tree and merging the
846                     # result may have produced the same tree as ours.
847                     git diff-index --quiet --cached HEAD -- && {
848                         say "$(gettext "No changes -- Patch already applied.")"
849                         go_next
850                         continue
851                     }
852                     # clear apply_status -- we have successfully merged.
853                     apply_status=0
854                 fi
855         fi
856         if test $apply_status != 0
857         then
858                 eval_gettextln 'Patch failed at $msgnum $FIRSTLINE'
859                 stop_here_user_resolve $this
860         fi
861
862         if test -x "$GIT_DIR"/hooks/pre-applypatch
863         then
864                 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
865         fi
866
867         tree=$(git write-tree) &&
868         commit=$(
869                 if test -n "$ignore_date"
870                 then
871                         GIT_AUTHOR_DATE=
872                 fi
873                 parent=$(git rev-parse --verify -q HEAD) ||
874                 say >&2 "$(gettext "applying to an empty history")"
875
876                 if test -n "$committer_date_is_author_date"
877                 then
878                         GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"
879                         export GIT_COMMITTER_DATE
880                 fi &&
881                 git commit-tree $tree ${parent:+-p} $parent <"$dotest/final-commit"
882         ) &&
883         git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
884         stop_here $this
885
886         if test -f "$dotest/original-commit"; then
887                 echo "$(cat "$dotest/original-commit") $commit" >> "$dotest/rewritten"
888         fi
889
890         if test -x "$GIT_DIR"/hooks/post-applypatch
891         then
892                 "$GIT_DIR"/hooks/post-applypatch
893         fi
894
895         go_next
896 done
897
898 if test -s "$dotest"/rewritten; then
899     git notes copy --for-rewrite=rebase < "$dotest"/rewritten
900     if test -x "$GIT_DIR"/hooks/post-rewrite; then
901         "$GIT_DIR"/hooks/post-rewrite rebase < "$dotest"/rewritten
902     fi
903 fi
904
905 rm -fr "$dotest"
906 git gc --auto